// 20110919 doodle: spheres centered on a parabola and lied on the focus and the directrix  

#declare with_axis=0;
#declare with_focus=0;
#declare with_parabola=0;
#declare with_plane=1;
#declare filled=1;
#declare outlined=1;
#declare ortho_camera=0;
#declare flat=1;
// ----------------------------------------
#include "colors.inc"

global_settings {
  assumed_gamma 1.0
}
// ----------------------------------------

#if(ortho_camera)
	camera {
		orthographic
		location <0,15,0>
		look_at<0,0,4>
	} 
#else
	camera {
	  location  <-1.0, 1.5, -4.0>
	  direction 1.5*z
	  right     x*image_width/image_height
	  look_at   <0.0, 0.0,  0.25>
	} 
#end

sky_sphere {
  pigment {
    gradient y
    color_map {
      [0.0 rgb <0.6,0.7,1.0>]
      [0.7 rgb <0.0,0.1,0.8>]
    }
  }
}

light_source {
  <0, 0, 0>            // light's position (translated below)
  color rgb <1, 1, 1>  // light's color
  translate <-30, 30, -30>
}
               
// Objects --------------------------------
// Params
#declare r=0.01;
#declare numx=50;                 
#declare numsphe=15;//7; //15;
#declare startx=<-4,0,0>;
#declare stopx=<4,0,0>;

// Parabola
#declare stepx=(stopx.x-startx.x)/numx;
#declare i=startx.x;
#declare parpar=sphere_sweep {
	linear_spline
	numx+2,
	<i,0,i*i>,r
	#while(i<=stopx.x)
		#local i=i+stepx;
		,<i,0,i*i>,r
	#end
}

// Spheres
#declare stepx=(stopx.x-startx.x)/numsphe;
#declare i=startx.x;
#declare parsphe=union {
	#while(i<=stopx.x)
		#if(filled)
			#if(flat)
				disc{<i,0+0.001*i,i*i>, y, i*i+0.25 pigment{color rgbt<0.5+0.5*i/(stopx.x-startx.x),.8-.3*i/(stopx.x-startx.x),0.6,0.8>}}
			#else
				sphere{<i,0,i*i> i*i+0.25 pigment{color rgbt<0.7+0.3*i/(stopx.x-startx.x),.6,0.6,0.9>}}
			#end
		#end
		#if(outlined)
			torus{i*i+0.25 r pigment{color rgb 0} translate <i,0,i*i>}
		#end
		#local i=i+stepx;
	#end
}

// ----------------------------------------


// Scene ----------------------------------

#if(with_plane)
	plane {
	  y, -10 //-0.002 //-10
	  pigment { color rgb <0.4,0.5,0.7> }
	}
#end

// Axis
#if(with_axis=1)
	sphere{0 0.1 pigment{color rgb x}}
	cylinder{<0,0,-10> <0,0,10> r pigment{color rgb y}}
	cylinder{<-10,0,0> <10,0,0> r pigment{color rgb y}}
	sphere{startx 0.1 pigment{color rgb x}}
	sphere{stopx 0.1 pigment{color rgb x}}
#end

// Focus and directrix
#if(with_focus=1)
	sphere{<0,0,0.25> r*2 pigment{color rgb z}}
	cylinder{<-10,0,-0.25> <10,0,-0.25> r pigment{color rgb z}}
#end

// Parabola
#if(with_parabola=1)
	object{parpar pigment{color rgb x+y}}
#end

//Spheres
object{parsphe}

// ----------------------------------------
